<?php
require('includes/application_top.php');
require(DIR_WS_INCLUDES . 'template_top.php');


$revechat_aid = $_GET['revechat_aid'];

if((isset($revechat_aid) && $revechat_aid != 0)){

    // select configuration group
    tep_db_query("DELETE FROM ".TABLE_CONFIGURATION." WHERE `configuration_key` = 'REVE_CHAT_AID' ");

    $sql_data_array = array('configuration_value' => $revechat_aid, 'configuration_key' => 'REVE_CHAT_AID');
    tep_db_perform(TABLE_CONFIGURATION, $sql_data_array, 'insert');
}

if(isset($_GET['revechat_remove'])){
    tep_db_query("UPDATE ".TABLE_CONFIGURATION." SET configuration_value = 0 WHERE `configuration_key` = 'REVE_CHAT_AID' ");
}
?>

<?php echo tep_draw_form('revechat-admin-settings-form', FILENAME_REVECHAT, '', 'get', 'id="revechat-admin-settings-form"');?>
    <div class="form-item form-type-item" id="edit-ajax-message">
        <p class="ajax_message">
        </p>
    </div>
<?php

$revechat_aid =  tep_db_query("SELECT configuration_value FROM configuration WHERE `configuration_key` = 'REVE_CHAT_AID' ");
$revechat_aid = tep_db_fetch_array($revechat_aid);

if($revechat_aid['configuration_value'] != 0):
    ?>
    <table class="container-fluid margin-top" cellspacing="2" cellpadding="2" border="0" width="90%">
        <tbody>

            <tr>
                <td> <h3>REVE Chat is installed.</h3></td>
            </tr>

            <tr>
                <td>Sign in to REVE Chat Dashboard and start chatting with your customers.</td>
            </tr>

            <tr>
                <td><a href="https://app.revechat.com" target="_blank">Go to Dashboard</a></td>
            </tr>

            <tr>
                <td>
                    <small>Something went wrong? <input type="submit" id="edit-submit" name="revechat_remove" value="Remove" style="background: transparent; border: 0; text-decoration: underline;text-transform: lowercase; font-size: 10px; cursor: pointer;"></small>
                </td>
            </tr>
        </tbody>
    </table>

<?php else: ?>

    <table cellspacing="0" cellpadding="0" border="0" width="90%">
        <tbody>
        <tr>
            <td valign="top" width="50%">
                <table id="revechat_choose_form">
                    <tr>
                        <td><h4>Already have a REVE Chat account?</h4></td>
                    </tr>
                    <tr>
                        <td>
                            <label>
                                <input type="radio" checked="checked" id="has_revechat_account" name="revechat_choose_form"> Yes, I already have a REVE Chat account
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <label>
                                <input type="radio" id="new_revechat_account" name="revechat_choose_form">
                                No, I want to create one
                            </label>
                        </td>
                    </tr>
                </table>
            </td>
            <td width="50%">
                <table id="revechat_already_have" width="100%">
                    <tr>
                        <td><h4>Account Details</h4></td>
                    </tr>
                    <tr>
                        <td>
                            <fieldset id="edit-general" class="form-wrapper">
                                <label class="control-label" for="edit-revechat-account-email">REVE Chat Login Email</label>
                                <input type="text" name="revechat_account_email" placeholder="Email" id="edit-revechat-account-email" class="form-control">
                                <input type="hidden" value="0" name="revechat_aid">
                            </fieldset>
                        </td>
                    </tr>
                </table>

                <table id="revechat_new_account" width="100%">
                    <tr>
                        <td><h4>Create a new REVE Chat account</h4></td>
                    </tr>
                    <tr>
                        <td>
                            <fieldset id="edit-new-revechat-account" class="form-wrapper">

                                <br>
                                <label class="control-label" for="firstName">First Name</label>
                                <div class="form-group">
                                    <input type="text" placeholder="First Name" name="firstName" id="firstName" class="form-control">
                                </div>


                                <br>
                                <label class="control-label" for="lastName">Last Name</label>
                                <div class="form-group">
                                    <input type="text" placeholder="Last Name" name="lastName" id="lastName" class="form-control">
                                </div>


                                <br>
                                <label class="control-label" for="newEmail">Email</label>
                                <div class="form-group">
                                    <input type="text" placeholder="Email" name="newEmail" id="newEmail" class="form-control">
                                </div>


                                <br>
                                <label class="control-label" for="accountPassword">Create Password</label>
                                <div class="form-group">
                                    <input type="Password" placeholder="Password" name="accountPassword" id="accountPassword" class="form-control">
                                </div>


                                <br>
                                <label class="control-label" for="retypePassword">Confirm your Password</label>
                                <div class="form-group">
                                    <input type="Password" placeholder="Password" name="retypePassword" id="retypePassword" class="form-control">
                                </div>

                            </fieldset>
                        </td>
                    </tr>
                </table>

                <table width="100%">
                    <tr>
                        <td>
                            <input type="submit" class="form-submit btn btn-warning" value="Submit" name="op" id="edit-submit">
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
        </tbody>
    </table>

<?php endif ?>
    </form>

    <script>
        jQuery(document).ready(function($) {
            $('head').append('<link rel="stylesheet" type="text/css" href="includes/revechat_styles.css">');

            jQuery.noConflict();
            (function($)
            {
                var ReveChatBaseUrl = 'https://app.revechat.com/';
                window.ExistingAccoutVerify = function (response) {

                    if (response.error)
                    {
                        $('.ajax_message').removeClass('wait').addClass('message alert').html('Incorrect REVE Chat login.');
                        $('#edit-revechat-account-email').focus();
                        return false;
                    }
                    else
                    {
                        if( response.data.account_id ) {

                            $('input[name=revechat_aid]').val(response.data.account_id);
                            $('#revechat-admin-settings-form').submit();

                        } else {
                            console.log(`Response Error: `,response);
                        }
                    }
                }
                var ReveChat =
                    {
                        init: function () {
                            this.toggleForms();
                            this.clearError();
                            this.bindFormSubmit();
                        },
                        toggleForms: function ()
                        {
                            this.clearError();
                            var toggleForms = function ()
                            {
                                if ($('#new_revechat_account').is(':checked'))
                                {
                                    $('#revechat_already_have').hide();
                                    $('#revechat_new_account').show();
                                }
                                else if ($('#has_revechat_account').is(':checked'))
                                {
                                    $('#revechat_new_account').hide();
                                    $('#revechat_already_have').show();
                                }
                            };
                            toggleForms();
                            $('#revechat_choose_form input').click(toggleForms);
                        },
                        bindFormSubmit: function () {
                            $('#revechat-admin-settings-form').submit(function(e)
                            {
                                //e.preventDefault();
                                if (((parseInt($('input[name=revechat_aid]').val()) !== 0)) || $('#has_revechat_account').is(':checked'))
                                {
                                    return ReveChat.alreadyHaveAccountForm();
                                }
                                else
                                {
                                    return ReveChat.newLicenseForm();
                                }

                            });
                        },
                        alreadyHaveAccountForm: function()
                        {
                            var login = $.trim($('#edit-revechat-account-email').val());

                            if(!ReveChat.isValidEmailAddress(login))
                            {
                                ReveChat.removeAlert();
                                ReveChat.showAlart($('input[name=revechat_account_email]'), 'alert', 'Invalid Email Address');
                                return false;
                            }


                            if((parseInt($('input[name=revechat_aid]').val()) == 0))
                            {

                                $('.ajax_message').removeClass('message').addClass('wait').html('Please wait&hellip;');
                                ReveChat.signIn($('#edit-revechat-account-email').val());
                                return false;
                            }

                            return true;
                        },
                        signIn: function(email)
                        {
                            var signInUrl = ReveChatBaseUrl +'/license/adminId/'+email+'/?callback=window.ExistingAccoutVerify';
                            $.ajax({
                                type: 'GET',
                                dataType: "text",
                                // dataType: "jsonp",
                                url: signInUrl, 
                                // jsonpCallback: "window.ExistingAccoutVerify",
                                beforeSend: function() {
                                },
                                success: function(response) {
                                    eval(response);
                                },
                                error: function(XMLHttpRequest, textStatus, errorThrown) {
                                    console.log("Error:1656");
                                }

                            }); // end of ajax saving.
                        },
                        newLicenseForm: function()
                        {
                            if (parseInt(($('input[name=revechat_aid]').val()) > 0))
                            {
                                return true;
                            }

                            if(this.validateNewLicenseForm())
                            {
                                $('.ajax_message').removeClass('message').addClass('wait').html('Please wait...');

                                ReveChat.createLicense();
                            }
                            return false;
                        },
                        createLicense: function()
                        {

                            $('.ajax_message').removeClass('message').addClass('wait').html('Creating new account&hellip;');

                            var signUpUrl = ReveChatBaseUrl + 'revechat/cms/api/signup.do';

                            var firstName = $.trim($('#firstName').val());
                            var lastName = $.trim($('#lastName').val());
                            var email = $.trim($('#newEmail').val());
                            var password = $.trim($('#accountPassword').val());
                            var rePassword = $.trim($('#retypePassword').val());



                            $.ajax({
                                data: { 'firstname':firstName, 'lastname':lastName, 'mailAddr':email, 'password':password },
                                type:'POST',
                                url:signUpUrl,
                                dataType: 'json',
                                cache:false,
                                success: function(response) {
                                    if(response.status == 'error')
                                    {
                                        ReveChat.removeAlert();
                                        ReveChat.showAlart($('#newEmail'), 'alert', response.message);
                                    }
                                    else if(response.status == 'success')
                                    {
                                        ReveChat.removeAlert();
                                        $('#edit-revechat-account-email').val(email);
                                        ReveChat.signIn(email);
                                    }

                                }
                            });
                        },
                        showAlart: function(elem, type, message)
                        {
                            $('.ajax_message').removeClass('wait').addClass('message '+type).html(message);
                            elem.addClass('error').focus();
                        },
                        removeAlert: function()
                        {
                            $('.ajax_message')
                                .removeClass('wait')
                                .removeClass('message')
                                .removeClass('alert')
                                .html('');
                        },
                        clearError: function()
                        {
                            this.removeAlert();
                        },
                        isValidEmailAddress: function (emailAddress) {
                            if($('#edit-submit').val()=='Remove'){
                                return true;
                            }
                            var pattern = /^([a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+(\.[a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+)*|"((([ \t]*\r\n)?[ \t]+)?([\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*(([ \t]*\r\n)?[ \t]+)?")@(([a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.)+([a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.?$/i;
                            return pattern.test(emailAddress);
                        },
                        validateNewLicenseForm: function()
                        {
                            var firstName = $.trim($('#firstName').val());
                            var lastName = $.trim($('#lastName').val());
                            var email = $.trim($('#newEmail').val());
                            var password = $.trim($('#accountPassword').val());
                            var rePassword = $.trim($('#retypePassword').val());


                            // validate the form
                            if(!firstName.length)
                            {
                                ReveChat.removeAlert();
                                ReveChat.showAlart($('#firstName'),'alert',"Please please provide your first name");
                                return false;
                            }

                            if(!lastName.length)
                            {
                                ReveChat.removeAlert();
                                ReveChat.showAlart($('#lastName'),'alert',"Please please provide your last name");
                                return false;
                            }

                            if(!ReveChat.isValidEmailAddress(email))
                            {
                                ReveChat.removeAlert();
                                ReveChat.showAlart($('#newEmail'),'alert',"Please please provide valid email address");
                                return false;
                            }

                            if(password.length < 6)
                            {
                                ReveChat.removeAlert();
                                ReveChat.showAlart($('#accountPassword'),'alert',"Please please provide your password. The password must be at least 6 characters long.");
                                return false;
                            }

                            if(!rePassword.length || password.length < 6)
                            {
                                ReveChat.removeAlert();
                                ReveChat.showAlart($('#retypePassword'),'alert',"Please please retype your password.");
                                return false;
                            }

                            if(password != rePassword)
                            {
                                ReveChat.removeAlert();
                                ReveChat.showAlart($('#edit-retypepassword'),'alert',"Password did not matched.");
                                $('#edit-retypepassword').focus();
                                return false;
                            }

                            return true;
                        }
                    }

                $(document).ready(function()
                {
                    ReveChat.init();
                });
            })(jQuery);
        });
    </script>
<?php
require(DIR_WS_INCLUDES . 'template_bottom.php');
require(DIR_WS_INCLUDES . 'application_bottom.php');
