<?php

class bm_revechat
{
    var $code = 'bm_revechat';
    var $group = 'boxes';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function bm_revechat() {
        $this->title = MODULE_BOXES_REVECHAT_TITLE;
        $this->description = MODULE_BOXES_REVECHAT_DESCRIPTION;

        if ( defined('MODULE_BOXES_REVECHAT_STATUS') ) {
            $this->sort_order = MODULE_BOXES_REVECHAT_SORT_ORDER;
            $this->enabled = (MODULE_BOXES_REVECHAT_STATUS == 'True');

            $this->group = 'boxes_column_left';
        }
    }

    function execute() {
        global $oscTemplate;

        if(REVE_CHAT_AID != 0 ){

            $data = ' <!-- Start of REVE Chat Script-->
                         <script type=\'text/javascript\'>
                         window.$_REVECHAT_API || (function(d, w) { var r = $_REVECHAT_API = function(c) {r._.push(c);}; w.__revechat_account="'.REVE_CHAT_AID.'";w.__revechat_version=2;
                           r._= []; var rc = d.createElement(\'script\'); rc.type = \'text/javascript\'; rc.async = true; rc.setAttribute(\'charset\', \'utf-8\');
                           rc.src = (\'https:\' == document.location.protocol ? \'https://\' : \'http://\') + \'static.revechat.com/widget/scripts/new-livechat.js?\'+new Date().getTime();
                           var s = d.getElementsByTagName(\'script\')[0]; s.parentNode.insertBefore(rc, s);
                         })(document, window);
                        </script>
                        <!-- End of REVE Chat Script -->';
            
            $oscTemplate->addBlock($data, $this->group);
        }

    }

    function isEnabled() {
        return $this->enabled;
    }

    function check() {
        return defined('MODULE_BOXES_REVECHAT_STATUS');
    }

    function install() {

        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable REVE Chat Module', 'MODULE_BOXES_REVECHAT_STATUS', 'True', 'Do you want to add the module to your shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

        tep_db_query("INSERT INTO " . TABLE_CONFIGURATION_GROUP . " (configuration_group_title, configuration_group_description, sort_order, visible) VALUES ('REVE Chat Configuration', 'Set REVE Chat Configuration Options', '1', '0');");
        $configuration_group_id = tep_db_insert_id();

        tep_db_query("UPDATE " . TABLE_CONFIGURATION_GROUP . " SET sort_order = " . $configuration_group_id . " WHERE configuration_group_id = " . $configuration_group_id . ";");

        tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) VALUES
            ('Version', 'REVE_CHAT_VERSION', '1.0.0', 'Version Installed:', " . $configuration_group_id . ", 0, NOW(), NULL, NULL),
            ('Account ID', 'REVE_CHAT_AID', '0', 'REVE Chat Account ID:', " . $configuration_group_id . ", 10, NOW(), NULL, NULL);");
    }

    function remove() {
        tep_db_query("DELETE FROM ".TABLE_CONFIGURATION_GROUP. " WHERE `configuration_group_title` = 'REVE Chat Configuration'");
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->revechat_configuration_keys()) . "')");
    }

    function keys() {
        return array('MODULE_BOXES_REVECHAT_STATUS');
    }

    function revechat_configuration_keys()
    {
        return array('REVE_CHAT_VERSION','REVE_CHAT_AID','REVE_CHAT_AID');
    }
}